// CAEgeXgvOR

#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "basic/oxfloat.h"
#include "test/testlayout.h"
#include "basic/oxmath.h"

TCHAR gName[] = _T("CAEgeXgvOR");

#define SAFERELEASE( x ) if( x ){ x->Release(); x = 0; }


using namespace OX;
using namespace OX::Layout;
struct Vtx {
	float x, y, z, w;
	DWORD color;
	Vtx(const Float2 &p) : x(p.x), y(p.y), z(), w(1.0f), color(0xffffffff) {}
	Vtx(const Float2 &p, DWORD color) : x(p.x), y(p.y), z(), w(1.0f), color(color) {}
};

void drawCursor(IDirect3DDevice9 *dev, float cursorX, float cursorY) {
	Vtx vtx[4] = {
		Vtx(Float2(-10.0f + cursorX, cursorY), 0xff0000ff), Vtx(Float2(10.0f + cursorX,  cursorY), 0xff0000ff),
		Vtx(Float2( cursorX, 10.0f + cursorY), 0xff0000ff), Vtx(Float2( cursorX,-10.0f + cursorY), 0xff0000ff),
	};
	dev->SetFVF(D3DFVF_XYZRHW | D3DFVF_DIFFUSE);
	dev->DrawPrimitiveUP(D3DPT_LINELIST, 2, vtx, sizeof(Vtx));
}

// EBhEvV[W
LRESULT CALLBACK WndProc( HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam ){
	if( mes == WM_DESTROY || mes == WM_CLOSE ) { PostQuitMessage( 0 ); return 0; }
	return DefWindowProc( hWnd, mes, wParam, lParam );
}

int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	// AvP[V̏
	MSG msg; HWND hWnd;
	WNDCLASSEX wcex = { sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL, (HBRUSH)(COLOR_WINDOW+1), NULL, (TCHAR*)gName, NULL};
	if( !RegisterClassEx(&wcex) )
		return 0;

	RECT R = { 0, 0, 640, 480 };
	AdjustWindowRect( &R, WS_OVERLAPPEDWINDOW, FALSE );
	if( !( hWnd = CreateWindow( gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, R.right - R.left, R.bottom - R.top, NULL, NULL, hInstance, NULL ) ) )
		return 0;

	// Direct3D̏
	LPDIRECT3D9 g_pD3D;
	LPDIRECT3DDEVICE9 g_pD3DDev;
	if( !( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) ) return 0;

	D3DPRESENT_PARAMETERS d3dpp = { 640, 480, D3DFMT_UNKNOWN, 0, D3DMULTISAMPLE_NONE, 0, D3DSWAPEFFECT_DISCARD, NULL, TRUE, TRUE, D3DFMT_D24S8, 0, D3DPRESENT_RATE_DEFAULT, D3DPRESENT_INTERVAL_DEFAULT }; 

	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
	{
	g_pD3D->Release();
	return 0;
	}

	///////////////////////////
	// CAEg
	////
	TurnRedObject obj;
	{
		RectRegion *region = new RectRegion(200.0f, 80.0f, 0.0f, 0.0f);
		region->setPivot(Float2(100.0f, 40.0f));
		obj.setRegion(region);

		Param param;
		param.trans = Float2(310.0f, 85.0f);
		param.rot = 30.0f;
		obj.setParam(param);
	}

	unsigned char buf[1024];	// obt@1KB

	////////////////////////////
	// }EX
	//////
	int cursorX, cursorY;
	Mouse mouse;

	////////////////////////////
	// AvIt@N^[
	////
	class AppEndFunctor : public Functor {
	public:
		bool bEnd;
		AppEndFunctor() : bEnd() {}
		virtual void run() {
			bEnd = true;
		}
	};
	sp<AppEndFunctor> appEndFunctor(new AppEndFunctor);
	obj.registerFunctor(appEndFunctor);

	ShowWindow(hWnd, nCmdShow);
	ShowCursor(FALSE);

	// bZ[W [v
	do{
		if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) ){
			DispatchMessage( &msg );
		}

		// J[\ʒuo
		POINT cursorPos;
		GetCursorPos(&cursorPos);
		ScreenToClient(hWnd, &cursorPos);
		cursorX = cursorPos.x;
		cursorY = cursorPos.y;

		Mouse::Data data;
		data.x = (float)cursorX;
		data.y = (float)cursorY;
		unsigned char LDown = GetAsyncKeyState(VK_LBUTTON) & 0x8000 ? 1 : 0;
		unsigned char RDown = GetAsyncKeyState(VK_RBUTTON) & 0x8000 ? 1 : 0;
		unsigned char MDown = GetAsyncKeyState(VK_MBUTTON) & 0x8000 ? 1 : 0;
		data.flag = (LDown << Mouse::L) | (RDown << Mouse::R) | (MDown << Mouse::M);
		mouse.update(data);

		// IuWFNgɃ}EXANV
		obj.mouseAction(mouse);

		// `X^[g
		g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(40,40,80), 1.0f, 0 );
		g_pD3DDev->BeginScene();

		// ̈悩璸_擾Ē_obt@쐬
		Region &region = *obj.getRegion().getPtr();
		const Param &param = obj.getParam();
		Vector<Float2> &vtx = region.getVertices();
		const Float2 &pv = region.getPivot();
		const float rot = OX::Math::toRad(param.rot);

		for (unsigned i = 0; i < vtx.size(); i++) {
			// ]邽߃s{bgWx_
			Float2 p = vtx[i] - pv;
			// ]
			Float2 rotP(cosf(rot) * p.x - sinf(rot) * p.y, sinf(rot) * p.x + cosf(rot) * p.y);
			// s{bgʒu֖߂
			p = rotP + pv;
			// Ɉړ
			p += param.trans;

			memcpy(buf + i * sizeof(Vtx), &Vtx(p, param.color), sizeof(Vtx));
		}
		g_pD3DDev->SetFVF(D3DFVF_XYZRHW | D3DFVF_DIFFUSE);
		g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, buf, sizeof(Vtx));

		// J[\ʒu`
		drawCursor(g_pD3DDev, (float)cursorX, (float)cursorY);

		// J[\ʒuHUD̃[Jʒu֕ϊ
		Float2 cp((float)cursorX, (float)cursorY);
		// @ tړ
		cp -= param.trans;
		// A ts{bgړ
		cp -= pv;
		// B t]
		Float2 invRotP(cosf(-rot) * cp.x - sinf(-rot) * cp.y, sinf(-rot) * cp.x + cosf(-rot) * cp.y);
		// C s{bgړ
		cp = invRotP + pv;
		drawCursor(g_pD3DDev, (float)cp.x, (float)cp.y);

		g_pD3DDev->EndScene();
		g_pD3DDev->Present( NULL, NULL, NULL, NULL );

	} while( msg.message != WM_QUIT && !appEndFunctor->bEnd);

	ShowCursor(TRUE);
	SAFERELEASE( g_pD3DDev );
	SAFERELEASE( g_pD3D );
	return 0;
}

